/**
 * Copyright:   Moonlight(Eric yue)
 * Email:       hi.moonlight@gmail.com
 * Website:     www.ericyue.info
 * File name:   LocationService.java 
 * Project Name:ExpressSensor
 * Create Date: 2011-8-18
 */
package info.ericyue.es.activity;

import java.io.IOException;

import info.ericyue.es.util.*;
import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.location.LocationManager;
import android.os.Bundle;
import android.os.Handler;
import android.os.IBinder;
import android.util.Log;

public class LocationService extends Service {
	private LocationManager locationManager;
	private Handler objHandler = new Handler();
	private String worker_id;
	private Bundle bundle;
	private long seconds;
	private WiFiAP wifiap=new WiFiAP(this);
	private LocationUtil locationUtil;
	private Runnable mTasks = new Runnable(){
		public void run(){			
			  try {
				locationUtil.executeListen();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			  Log.i("ݶ", "λ÷...");
			  seconds=(long)Integer.parseInt(SettingsActivity.getUpdateTime(LocationService.this));
			  objHandler.postDelayed(mTasks, 10000);
		  } 
	  };

	  @Override
	  public void onStart(Intent intent, int startId){
	    super.onStart(intent, startId);
	    bundle=intent.getExtras();
	    worker_id=intent.getExtras().getString("worker_id");
	    locationUtil=new LocationUtil(bundle,locationManager,LocationService.this,worker_id,wifiap);
	  }
	  @Override
	  public void onCreate(){
	    /* ʼÿ1mTasks߳ */
		  locationManager= (LocationManager) getSystemService(Context.LOCATION_SERVICE);
		  seconds=(long)Integer.parseInt(SettingsActivity.getTraceTime(this));
		  objHandler.postDelayed(mTasks, seconds);
	      super.onCreate();
	  }
	  @Override
	  public IBinder onBind(Intent intent){
	    /* IBinderΪServiceдķ */
	    return null;
	  }
	  @Override
	  public void onDestroy(){
	    /* ƳmTasks߳ */
	    objHandler.removeCallbacks(mTasks);
	    super.onDestroy();
	  }  

}
